﻿Imports System.Text
Imports System.Threading
Imports System.Windows.Forms
Imports Timer = System.Windows.Forms.Timer

Public Class Form1

    Private rpt As LongRunningReport = Nothing
    Private reportThread As Thread = Nothing
    Private recordCount As Integer = 0
    Private timer As Timer

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Me.StartNewReport()
    End Sub

    Private Sub btnStopReport_Click(sender As System.Object, e As System.EventArgs) Handles btnStopReport.Click
        timer1.Enabled = False
        label1.Visible = False
        Me.StopReport()
    End Sub

    Private Sub btnStartNewReport_Click(sender As System.Object, e As System.EventArgs) Handles btnStartNewReport.Click
        Me.StartNewReport()
    End Sub

    Private Sub StopReport()
        Try
            If rpt Is Nothing Then
                Return
            End If
            StopTimer()
            recordCount = 0
            rpt.[Stop]()

            If Me.reportThread IsNot Nothing Then
                If Me.reportThread.IsAlive Then
                    Me.reportThread.Abort()
                End If
            End If
        Catch generatedExceptionName As Exception
            System.Diagnostics.Debug.WriteLine("An error occured while stopping the report.")
        End Try
    End Sub

    Private Sub StartNewReport()
        timer1.Enabled = False
        label1.Visible = True
        label1.Text = ""

        Me.StopReport()

        ' Initialize the report
        Me.rpt = New LongRunningReport()

        'The next few lines are just to provide a dummy datasource for the report
        'A datatable with lots of records to make it a large report.
        Dim dt As New DataTable()
        dt.Columns.Add("Index", GetType(Integer))

        For i As Integer = 1 To 39999
            dt.Rows.Add(i)
        Next
        rpt.DataSource = dt


        'Make an event handler for FetchData
        AddHandler rpt.FetchData, AddressOf rpt_FetchData


        ' Set the total number of records to the Maximum.
        progressBar1.Minimum = 0
        progressBar1.Maximum = rpt.GetNoOfRecords(rpt.DataSource)

        'Now, create a timer which will check the progress periodically.
        timer = New Timer()
        timer.Interval = 100
        AddHandler timer.Tick, AddressOf CheckProgress
        timer.Start()

        ' Hook it up to the document
        Me.Viewer1.Document = rpt.Document
        ' Create a thread to execute the Run method in:
        Me.reportThread = New Thread(New ThreadStart(AddressOf rpt.Run))
        ' Start the thread:
        Me.reportThread.Start()
    End Sub

    Private Sub rpt_FetchData(sender As Object, eArgs As GrapeCity.ActiveReports.SectionReport.FetchEventArgs)
        recordCount += 1
    End Sub

    Protected Overrides Sub Dispose(disposing As Boolean)
        ' Make sure that report runner thread is not still running, or the process won't stop.
        Me.StopReport()

        If disposing Then
            If components IsNot Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private Sub CheckProgress(sender As Object, e As EventArgs)
        If progressBar1.Maximum > recordCount Then
            progressBar1.Value = recordCount
            label1.Text = CInt((progressBar1.Value * 100) / progressBar1.Maximum).ToString() & "%"
        Else
            timer1.Enabled = True
            label1.Text = "Done!"
            progressBar1.Value = progressBar1.Maximum
            StopTimer()
        End If
    End Sub

    Private Sub StopTimer()
        recordCount = 0
        timer.[Stop]()
    End Sub

    Private Sub timer1_Tick(sender As Object, e As EventArgs)
        'This timer is used to show that the report generation is over
        timer1.Interval = 500
        label1.Visible = Not label1.Visible
    End Sub

End Class
